#ifndef __GTKCONTAINER_H__
#define __GTKCONTAINER_H__

#include <gtk/gtkhbox.h>
#include <gtk/gtkentry.h>
#include <gnome-xml/tree.h>

#include "gtkxmlmodules.h"
#include "gtkxmlview.h"
#include "gtkxmlmodules.h"

#ifdef __cplusplus
extern "C" {
#endif


#define TYPE_GTK_XML_CONTAINER				(gtk_xml_container_get_type())
#define GTK_XML_CONTAINER(obj)				(GTK_CHECK_CAST((obj),TYPE_GTK_XML_CONTAINER, GtkXmlContainer))
#define GTK_XML_CONTAINER_CLASS(klass)		(GTK_CHECK_CLASS_CAST((klass), TYPE_GTK_XML_CONTAINER, GtkXmlContainerClass))
#define IS_GTK_XML_CONTAINER(obj)			(GTK_CHECK_TYPE((obj), TYPE_GTK_XML_CONTAINER))
#define IS_GTK_XML_CONTAINER_CLASS(klass)	(GTK_CHECK_CLASS_TYPE((klass), TYPE_GTK_XML_CONTAINER))


typedef struct _GtkXmlContainer GtkXmlContainer;
typedef struct _GtkXmlContainerClass GtkXmlContainerClass;

struct _GtkXmlContainer{
	GtkHBox box;
	GtkXmlModules* modules;
	GtkWidget* editor;
	GtkXmlView* view;
	xmlDocPtr doc;
	gpointer private_data;
};

struct _GtkXmlContainerClass{
	GtkHBoxClass parent_class;
	
	void (*document_changed) (GtkXmlContainer* container, xmlDoc* doc, gpointer data );
	void (*node_changed) (GtkXmlContainer* container, xmlNode* node, gpointer data);
	void (*view_changed) (GtkXmlContainer* container, GtkXmlView* view, gpointer data );
	void (*editor_changed) (GtkXmlContainer* container, GtkWidget* widget, gpointer data );
};

GtkWidget* gtk_xml_container_new( GtkXmlModules* modules );

xmlDoc* gtk_xml_container_get_document( GtkXmlContainer* container );
xmlDoc* gtk_xml_container_set_document( GtkXmlContainer *container, xmlDoc* doc );
xmlNode* gtk_xml_container_get_current_node( GtkXmlContainer* container );
GtkXmlModules* gtk_xml_container_get_modules( GtkXmlContainer* container );

GtkXmlView* gtk_xml_container_get_view( GtkXmlContainer* container );
void gtk_xml_container_set_view( GtkXmlContainer* container, GtkXmlView* view );
void gtk_xml_container_set_editor( GtkXmlContainer* container, GtkWidget* editor );
GtkWidget* gtk_xml_container_get_editor( GtkXmlContainer* container );


#ifdef __cplusplus
}
#endif

#endif
