#include <glib.h>
#include <gmodule.h>
#include <gtk/gtk.h>
#include <gnome-xml/tree.h>

#ifndef _XML_MODULES_
#define _XML_MODULES_


#define MODULE_IMPORT 0x1
#define MODULE_EXPORT 0x2
#define MODULE_EDITOR 0x4
#define MODULE_VIEW   0x8

typedef struct _ModuleList ModuleList;
typedef struct _ModuleInfo ModuleInfo;


struct _ModuleList{
	GHashTable* table;
	GList* list;
}_ModuleList;

struct _ModuleInfo{
	int type;
	gchar* name;
	gboolean enabled;
	GModule* module;

	ModuleList* container;
	gchar* glade_file;
	GtkContainer* content;

	/** methods on our module
	 */

	void (*init) (ModuleInfo* info);
	void (*destroy) (gpointer obj);
	void (*enable) (gpointer obj);
	void (*disable) (gpointer obj);

	/** User parameters */
	gchar* help;
	gchar** attributes;
	gpointer user_data;
}_ModuleInfo;

ModuleList* mod_new();
ModuleList* mod_load_list( ModuleList* list, xmlDoc* doc );

ModuleInfo* mod_add_module( ModuleList* list, gchar* filename );
ModuleInfo* mod_add_attribute( ModuleInfo* info, gchar* name, gchar* value );

ModuleInfo* mod_get_module_info( ModuleList* list, gchar* name );
GModule*		mod_get_module( ModuleList* list, gchar* name );

gchar* mod_get_attribute( ModuleInfo* info, gchar* name );
gchar** mod_get_attributes( ModuleInfo* info, gchar* name );

#endif
